// PGM file input/output routines
// By Jason Chung
// 02/02/2004
// Stat130D, Winter 2004, UCLA Statistics
// http://www.stat.ucla.edu/%7Edinov/courses_students.dir/04/Winter/STAT130D.dir/STAT130D.html

// INCLUDES
#include<fstream.H >

	// Input "file-name" "2D int array of dimension sizes" for the PGM file image
	// Output "unsigned char array (1D) of the 2D image"
unsigned char * read_pgm(char* filename, int * dim_sizes)
{
	ifstream fin(filename);
	if(!fin) {
		cout << "Error reading " << filename<< "!!!" << endl;
		exit(-1);
	}

	char tmp[100];
	int i,j;
	fin>>tmp;		// Read the Header part of PGM file that contains "P2"	
	fin >> dim_sizes[0] >> dim_sizes[1];		// Read the dimension of the PGM image
	fin>>tmp;		// Read the maximum gray level. i.e. 255	

	cout << "Reading " << dim_sizes[0] << "x" << dim_sizes[1] << " pixels image from PGM file: "
		  << filename << " ..." << endl;
	
	unsigned char * imagePGM;
	imagePGM = new unsigned char[dim_sizes[0] * dim_sizes[1]];
  
	int count=0;
	for (i=0; i < dim_sizes[0] * dim_sizes[1]; i++)
	{ 	fin >> imagePGM[i];
		count++;
	}
	cout << "Total pixels read = " << count << endl;
	fin.close();

	return (imagePGM);
}


	// Writes out an input "unsigned char array" into a PGM file-format
void output_to_file_pgm(char* filename, unsigned char * myArray, int * dim_sizes){	
	ofstream fout(filename);
	if(!fout) {
		cout << "Error opening  " << filename << "!!!" << endl;
		exit(-1);
	}
	fout << "P2" <<endl;
	fout << dim_sizes[0] << " " << dim_sizes[1] <<endl;
	fout << "255" << endl;;

	int i, counter=1;

	for (i = 0; i < dim_sizes[0]*dim_sizes[1]; i++) 
	{	fout << (int)myArray[i] << " ";
			if(counter%17 == 0)
				fout << endl;
			counter++;
	}
	fout.close();
	return;
}